  ;  ,     COM 
  ;V1.1     8   
   
   processor 12f675  ; PIC12F675
   #include <p12f675.inc>
   __config  B'01000111001010'
   ;           ||||||||||||||   
   ;           |||||||||||||*-- \  
   ;           ||||||||||||*--- | 010 - HS ( )
   ;           |||||||||||*---- /          ( 20 )
   ;           ||||||||||*--WDT 0- 1-
   ;           |||||||||*---PWRT 0- 1-
   ;           ||||||||*----MCLR 0-  1-
   ;           |||||||*-----BOR  0-  BOR 1-
   ;           ||||||*------CP   0- 1-
   ;           |||||*-------CPD  EEPROM 0- 1-
   ;           ||||*-- \ 
   ;           |||*--- | 
   ;           ||*---- / 
   ;           |*--\  BOR
   ;           *---/     
   
   ;   
   ;define _debug_

   ;     RS-232
   ;    1 -> -12V   0 -> +12V
   ;       1 -> +12V   0 -> -12V
   ;      COM-   ,     MAX-232  .
   #define _invert_  

   ;     8    RS232
   #define _autosync_

  ; 20 
  ;RS-232 115200 .   8.6806 
  
  ;-------------------------------------------------------------
  ;  :
  ;  
  ;              --__--    
  ;      +5V---1|      |8--
  ;   20|-2|      |7-<--AN0 (GPIO0)
  ;  |-3|      |6-<--AN1 (GPIO1)
  ;   GP3-->-- 4|      |5->--GPIO2 TxD
  ;   .   ------  (/ TxD)
  ;   (-MCLR)
  ;  
  ;-------------------------------------------------------------
  
  ;,       TxD
TxDm:  macro ;  RS232 -12 V
        ifndef _invert_
         bsf GPIO,2 ;   1=-12
        else
         bcf GPIO,2 ;  0=-12
        endif
       endm
  
TxDp:  macro ;  RS232 +12 V
       ifndef _invert_
         bcf GPIO,2 ;   0=+12
       else
         bsf GPIO,2 ;  1=+12
       endif
       endm

TxDc:  macro ;  GPIO,2 ( 2)   C ( 0)
        ; STATUS  W.  2      GPIO
        ;   . 1=1 0=0        .  ,   .       .
        rlf STATUS,w
        movwf tmp0
        rlf tmp0,w
        movwf GPIO
       endm


TxDd:  macro ;   
        ifndef _invert_
          movlw 0x00;   
        else
          movlw 0xFF ;  
        endif
        xorwf dd,w
        nop
        movwf GPIO ;    
       endm




TxDm0: macro ;    0  
         ifndef _invert_
          movlw 0x00;   
         else
          movlw 0xFF ;  
        endif
        xorwf a00,f
        xorwf a01,f
       endm



TxDm1: macro ;    1  
        ifndef _invert_
          movlw 0x00;   
        else
          movlw 0xFF ;  
        endif
        xorwf a10,f
        xorwf a11,f
       endm


TxDmD: macro ;     
        ifndef _invert_
          movlw 0x00;   
        else
          movlw 0xFF ;  
        endif
        xorwf dd,f
       endm



TxT0:  macro ;  0     (Ft=5 )
        movlw D'226'
        movwf TMR0 
      endm
      

TxT1   macro ;  0     (Ft=5 )
        movlw D'227'
        movwf TMR0 
      endm


TxT2   macro ;  0     (Ft=5 )
        movlw D'224'
        movwf TMR0 
      endm

      
;   RS232  

;----------------------------------------------------------------
; 
tmp0: equ 0x20;   
      ;  RS-232   
      ;     RS-232

status_temp: equ 0x21;  STATUS   
w_temp: equ 0x22; W   
sub: equ 0x23;     

a00:  equ 0x24 ;       0
a01:  equ 0x25 ;       0
a10:  equ 0x26 ;       1
a11:  equ 0x27 ;       0
dd:   equ 0x28 ;    00  FF

;----------------------------------------------------------------



   org 0x0000  ;      
   bcf INTCON,GIE;     ( goto 0)   
   ;goto debug
   goto Init 
    
    
   org 0x0004  ;  (  44 )
;debug:   
  ;     ,          .
  ;,   ,          .
   movwf  w_temp  
   swapf  STATUS,w
   movwf  status_temp
   ; STATUS  W 
   movf sub,w
   addwf PCL,f ;   
   goto sub00
   goto sub01
   goto sub02
   goto sub03
   goto sub04
   goto sub05
   goto sub06
   goto sub07
   goto sub08
   goto sub09
   goto sub10
   goto sub11
   goto sub12
   goto sub13
   goto sub14
   goto sub15
   goto sub16
   goto sub17
   goto sub18
   goto sub19
   goto sub20
   goto sub21
   goto sub22
   goto sub23
   goto sub24
   goto sub25
   goto sub26
   goto sub27
   goto sub28
   goto sub29
   ;       _autosync_
   goto sub30
   goto sub31
   goto sub32
   goto sub33
   goto sub34
   goto sub35
   goto sub36
   goto sub37





   ;  STATUS  W    
exit:
   incf  sub,f;  
exit0:   
   bcf   INTCON,T0IF;     TMR0
   swapf status_temp,w
   movwf STATUS
   swapf w_temp,f
   swapf w_temp,w
   retfie;    

; 

sub00:;   0
   TxT0;     
   ;  4      
   ;     0
   movf ADRESH,w
   movwf a01
   nop
   nop
   TxDp; +12V     
   ;     0
   Banksel ADRESL
   errorlevel -302 ;      0
   movf ADRESL,w
   movwf a00
   Banksel ADRESH
   errorlevel +302 ;     0
   TxDm0; ,      0    
   ;    1
   bsf ADCON0,1 
   goto exit
   
sub01:
   TxT0;     
   ;  D0     0
   rrf a00,f;   C
   TxDc ;   GPIO2
   ;      0
   bcf ADCON0,2
   goto exit

sub02:
   TxT0;     
   ;  D1     0
   rrf a00,f;   C
   TxDc ;   GPIO2
   goto exit

sub03:
   TxT1;     
   ;  D2     0
   rrf a00,f;   C
   TxDc ;   GPIO2
   goto exit

sub04:
   TxT0;     
   ;  D3     0
   rrf a00,f;   C
   TxDc ;   GPIO2
   goto exit

sub05:
   TxT0;     
   ;  D4     0
   rrf a00,f;   C
   TxDc ;   GPIO2
   goto exit

sub06:
   TxT0;     
   ;  D5     0
   rrf a00,f;   C
   TxDc ;   GPIO2
   goto exit

sub07:
   TxT2;     
   ;  D6     0
   rrf a00,f;   C
   TxDc ;   GPIO2
   goto exit

sub08:
   TxT0;     
   ;  4      
   nop
   nop
   nop
   nop
   TxDm;  -12V (D7=1)   
   ;   
   rrf GPIO, w  ; D3 --> D2
   movwf dd
   goto exit

sub09:;   0
   TxT0;     
   ;  4      
   nop
   nop
   nop
   nop
   TxDm;  -12V   
   goto exit

sub10:;   1
   TxT0;     
   ;  4      
   nop
   nop
   nop
   nop
   TxDp;  +12V    
   goto exit

sub11:
   TxT0;     
   ;  D7     0
   rrf a00,f;   C
   TxDc ;   GPIO2
   goto exit

sub12:
   TxT0;     
   ;  D8     0
   rrf a01,f;   C
   TxDc ;   GPIO2
   goto exit

sub13:
   TxT1;     
   ;  D9     0
   rrf a01,f;   C
   TxDc ;   GPIO2
   goto exit

sub14:
   TxT0;     
   ;   
   TxDd
   ;     1
   movf ADRESH,w
   movwf a11
   Banksel ADRESL
   errorlevel -302 ;      0
   movf ADRESL,w
   movwf a10
   Banksel ADRESH
   errorlevel +302 ;     0
   TxDm1; ,      1    
   ;      14 ,      19
   #ifndef _autosync_
     ;    0
     bsf ADCON0,1 
   #endif
   goto exit

sub15:
   TxT0;     
   ;  D0     1
   rrf a10,f;   C
   TxDc ;   GPIO2
   ;     15 ,      20
   #ifndef _autosync_
     ;      1
     bsf ADCON0,2
   #endif
   goto exit

sub16:
   TxT0;     
   ;  D1     1   
   rrf a10,f;   C
   TxDc ;   GPIO2
   goto exit

sub17:
   TxT2;     
   ;  D2     1   
   rrf a10,f;   C
   TxDc ;   GPIO2
   goto exit

sub18:
   TxT0;     
   ;  4      
   nop
   nop
   nop
   nop 
   TxDp;  +12V (D7=0)   
   goto exit

sub19:;   1
   TxT0;     
   ;  4      
   nop
   nop
   nop
   nop 
   TxDm;  -12V   
   nop
   nop
   nop
   nop
   nop
   nop
   nop
   nop
   nop
   nop
   ;      14 ,      19
   #ifdef _autosync_
     ;    0
     bsf ADCON0,1 
   #endif
   goto exit

sub20:;   2
   TxT0;     
   ;  4      
   nop
   nop
   nop
   nop 
   TxDp;  +12V   
   ;     15 ,      20
   #ifdef _autosync_
     ;      1
     bsf ADCON0,2
   #endif
   goto exit

sub21:
   TxT0;     
   ;  D3     1   
   rrf a10,f;   C
   TxDc ;   GPIO2
   goto exit

sub22:
   TxT0;     
   ;  D4     1   
   rrf a10,f;   C
   TxDc ;   GPIO2
   goto exit

sub23:
   TxT1;     
   ;  D5     1   
   rrf a10,f;   C
   TxDc ;   GPIO2
   goto exit

sub24:
   TxT0;     
   ;  D6     1   
   rrf a10,f;   C
   TxDc ;   GPIO2
   goto exit

sub25:
   TxT0;     
   ;  D7     1   
   rrf a10,f;   C
   TxDc ;   GPIO2
   goto exit

sub26:
   TxT0;     
   ;  D8     1   
   rrf a11,f;   C
   TxDc ;   GPIO2
   goto exit

sub27:
   TxT2;     
   ;  D9     1   
   rrf a11,f;   C
   TxDc ;   GPIO2
   goto exit

sub28:
   TxT0;     
   ;  4      
   nop
   nop
   nop
   nop 
   TxDp;  +12V (D7=0)   
   goto exit

sub29:;   2
   TxT0;     
   ;  4      
   nop
   nop
   nop
   nop 
   TxDm;  -12V    
   clrwdt ;  
   #ifndef _autosync_
     clrf sub ;    
     goto exit0
   #else
    goto exit;      1
   #endif

    ; sub30 ... sub37     _autosync_  
    ;  8  (+    )  
    ;     
    ;    

sub30:
   TxT0;     
   goto exit


sub31:
   TxT1;     
   goto exit

sub32:
   TxT0;     
   goto exit

sub33:
   TxT0;     
   goto exit

sub34:
   TxT0;     
   goto exit

sub35:
   TxT0;     
   goto exit

sub36:
   TxT0;     
   goto exit

sub37:
   TxT0;     
   clrf sub ;    
   goto exit0


;==========================================

Init:; 

   bcf STATUS,RP0;   0

   movlw B'00100000'; INTCON 
;          |||||||| ;<   TMR0>
;          |||||||*-- GPIF  .  GPIO 0- 1- .
;          ||||||*--- INTF  .  INT 0- 1- .
;          |||||*---- T0IF  .  TMR0 0- 1- .
;          ||||*- GPIE .  .  GPIO 0-. 1-.    
;          |||*- INTE  . INT 0- 1-
;          ||*- T0IE .  TMR0 0-, 1-
;          |*-- PEIE .  0-, 1-
;          *--- GIE  0- . ., 1-
   movwf INTCON
   movlw B'00000111'; 
;          |||||||| ;<  >
;          |||||||*-- CMC0 \
;          ||||||*--- CMC1  }   
;          |||||*---- CMC2 / (111- )
;          ||||*- CIS   
;          |||*-- CINV   
;          ||*- x
;          |*-- CMOUT   
;          *--- x 
   movwf CMCON
   movlw B'10000001'; 
;          |||||||| ;< , ,  Vdd>
;          |||||||*-- ADON   0 - , 1- 
;          ||||||*--- GO/DONE 0-  1- 
;          |||||*-- CHS0 \ 
;          ||||*--- CHS1 /   
;          |||*-- x 
;          ||*--- x 
;          |*-- VCGF  0 - Vdd 1 -  Vref
;          *--- ADFM   0- 1 
   movwf ADCON0

   bsf STATUS,RP0;   1
   errorlevel -302 ;      0

   movlw B'00001111'; OPTION_REG 
;          |||||||| ;< ,   WDT>
;          |||||||*--PS0 \
;          ||||||*---PS1  }   
;          |||||*----PS2 /  (111  - 1:128)
;          ||||*- PSA  0- TMR0 1- WDT     
;          |||*-T0SE  .. TMR0 0- 1- 
;          ||*- T0CS  TMR0 0- 1-
;          |*-- INTEDG    INT 0- 1-
;          *--- GPPU  0- , 1- 
   movwf OPTION_REG 
   movlw B'00000000'; PIE1 
;          |||||||| ;<   >
;          |||||||*-- TMR1E   TMR1 0- 1-
;          ||||||*--- x
;          |||||*---- x
;          ||||*- CMIE    0- 1-
;          |||*-- x
;          ||*--- x
;          |*-- ADIE    0- 1-
;          *--- EEIE   EEPROM 0- 1-
   movwf PIE1 
   movlw B'00100011';      
;          |||||||| ;<   AN0, AN1.  1.6 >
;          |||||||*-- ANS0 \   
;          ||||||*--- ANS1  \ 0- 1-
;          |||||*---- ANS2  /
;          ||||*----- ANS3 /
;          |||*-- ADCS0 \     
;          ||*--- ADCS1  } (010 - 32Tosc.   20  
;          |*---- ADCS2 /    1.6 )
;          *--- x 
   movwf ANSEL 
   movlw B'00111011'; GPIO       
;          |||||||| ;<GPIO2 ,   >
;          |||||||*-- TRISIO0 GPIO0 0- 1-
;          ||||||*--- TRISIO1 GPIO1 0- 1-
;          |||||*---- TRISIO2 GPIO2 0- 1-
;          ||||*----- TRISIO3 GPIO3 1- ( )
;          |||*------ TRISIO4 GPIO4 0- 1-
;          ||*------- TRISIO5 GPIO5 0- 1-
;          |*-------- x
;          *--------- x
   movwf TRISIO 
   movlw B'00000000';      GPIO 
;          |||||||| ;<   >
;          |||||||*-- WPU0   0- 1-
;          ||||||*--- WPU1   0- 1- 
;          |||||*---- WPU2   0- 1-
;          ||||*----- x
;          |||*------ WPU4   0- 1-
;          ||*------- WPU5   0- 1-
;          |*-------- x
;          *--------- x
   movwf WPU 
   movlw B'00000000';     GPIO
;          |||||||| ;<    >
;          |||||||*-- IOCB0 GPIO0 0-  1-
;          ||||||*--- IOCB1 GPIO1 0-  1-
;          |||||*---- IOCB2 GPIO2 0-  1-
;          ||||*----- IOCB3 GPIO3 0-  1-
;          |||*------ IOCB4 GPIO4 0-  1-
;          ||*------- IOCB5 GPIO5 0-  1-
;          |*-------- x
;          *--------- x
   movwf IOCB 
   bcf STATUS,RP0;   0
   errorlevel +302 ;     0

  

   ;  RS-232
   ;  RS-232 (TxD=-12V)
   banksel GPIO
   TxDm;    RS-232
   
   ;       (  RS-232)
   ; 1000  .. 200   2.3 
   #ifndef _debug_ ;   ,    
   movlw D'200'
   movwf tmp0    
LoopRS200:;  200  
   nop
   nop
   decfsz tmp0,f
   goto LoopRS200
   ;   200 
   #endif   
   
  ;      
   clrf dd
   clrf a00
   clrf a01
   clrf a10
   clrf a11
   
   
      
;========================================

InitI:  ;   
  clrf sub;   
  TxT0;  0     
  bsf INTCON,GIE;    
  
  

Main:;   .        .
   goto Main

; ===========================================
   end
